<?php
/* findThemes.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; version 2 of the License.              |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: findThemes.inc.php,v 1.4.2.2 2003/01/13 01:37:25 AlberT Exp $
*/

/** _AES_getThemesDirName($dir)
 *
 * Get the names of all dirs under "themes" dir
 * Parameter:
 *  $dir - Themes directory
 *
 * Return value:
 *  0 - error
 *  array - ok
 *
 * Global references:
 *  $AES_ignoredThemes
 *  $AES_disabledThemes
 *
 */

function &_AES_getThemes($directory)
{
	global $AES_themes, $AES_ignoredThemes, $AES_disabledThemes;

	$AES_themes         = array();
	$AES_ignoredThemes  = array();

	// directories like "\foo\08012001" (on win systems) bring to an error
	//  such a name, containing the special '\0' char, will terminate
	//  prematurely the string.
	$directory = str_replace('\0', "\\0", $directory);
	$dh = @opendir($directory);
	// Under Windows NT opendir() seems to return a resource even for
	//  a non-existent directory; we use is_dir to avoid it.
	if (!$dh) {
		if (!@is_dir($directory)) {
			AES_print( sprintf(_("Cannot open directory '%s'. It is NOT a ".
			           "directory!"), $directory) );
		}
		elseif (!@is_readable($directory)) {
			AES_print( sprintf(_("Cannot open directory '%s'. It MUST be ".
			           "readable (+r)!"), $directory) );
		}
		// check that dir il executable, if it isn't is_dir() used below 
		// doesn't works properly!
		elseif (!@is_executable($directory)) {
			AES_print( sprintf(_("Directory '%s' MUST be executable (+x)!"),
			           $directory) );
		}
		AES_print( sprintf(_("Cannot open directory '%s'.. Unexpected error!"),
		           $directory));
	return FALSE;
	}
	//this handle strange entries like a dir named '0'
	while (FALSE !== ($entry = @readdir($dh))) {
		if ($entry != '.' && $entry != '..') {
			$dir = "$directory/$entry";
			// files will be ignored! Each theme MUST have its own dir
			if (@is_dir($dir)) {
				if (is_readable($dir.'/defaultPage.thm.php')) {
					if (@in_array($entry, $AES_disabledThemes, TRUE)) {
						AES_print( sprintf(_("Theme '<b>%s</b>' is present ".
						           "but <font color=\"red\">disabled</font>."),
						           $entry) );
					}
					$AES_themes[] = $entry;
				}
				else {
					$AES_ignoredThemes[] = $entry;
					AES_print( sprintf(_("Directory <b>'%s'</b> seems NOT to ".
					           "be a valid AES theme dir: it DOES NOT contain".
					           " the file defaultPage.thm.php or this file ".
					           "is NOT readable by the web server !!!"),
					           $dir) );
				}
			}
		}
	}
	@closedir($dh);
	return TRUE;
}
//}} _AES_getThemesDirName()

/*
 * Load themes in includer directory
 */
_AES_getThemes(AES_SITE_PATH.'/themes');

$tmp = '';
foreach ($AES_themes as $t) {
	$tmp .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b><u>'.$t."</u></b>&nbsp;\n";
}
AES_print(_(" Found the following valid <b>themes</b>:\n").substr($tmp, 0, -1));
unset($tmp);

?>
