<?php
/* errors.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: handleErrors.inc.php,v 1.1.2.4 2003/01/13 01:37:25 AlberT Exp $
 */

require_once dirname(__FILE__).'/modules/ErrorHandler/ErrorHandler.inc.php';
$__error =& new ErrorHandler();

define('E_AES_DEBUG',    0x10000000>>2);

function AES_debug($msg, $var)
{
	return AES_print(1);
}

function AES_print($variable, $level=0, $name='""', $file_name='""', $line='""')
{
	$eh =& $GLOBALS['__error'];
	if ($level & E_AES_DEBUG || !$level) {
		if (defined('AES_DEBUG') && AES_DEBUG!==TRUE)
			return;
		$eh->_lockreset();
		$message = $eh->_message($level, '', '', $variable);
		//$context = $eh->_sprint_var($variable, $name, 0);
		$eh->_logall($level, '', $message . "\n");
		$eh->_output($message, '', '');
	}
	else {
		$eh->_lockreset();
		$message = $eh->_message($level, $file_name, $line, $variable);
		$context = $eh->_sprint_var($variable, $name, 0);
		$eh->_logall($level, '', $message . "\n");
		$eh->_output($message, '', '');
	}
}

// creates own error message (used by ErrorHandler)
function _AES_e_message($err_str, $level, $file_name, $line_no)
{
	$eh =& $GLOBALS['__error'];
	$message = date(ERRORHANDLER_DATE_FORMAT);

	if ($level & E_ERROR_ALL) {
		$message .= ' - ERROR ';
	}
	elseif ($level & E_WARNING_ALL) {
		$message .= ' - WARNING ';
	}
	elseif ($level & E_NOTICE_ALL) {
		$message .= ' - NOTICE ';
	}
	elseif ($level & E_AES_DEBUG ) {
		$message = ' AES_DEBUG: ';
		$message .= sprintf("%s ", $err_str);

	}
	elseif ($level & E_DEBUG) {
		$message = ' DEBUG: ';
		$message .= sprintf("%s\n", $err_str);

	}
	elseif ($level & E_LOG) {
		$message .= ' - LOG message ';
	}
	// if SOURCE report is required, $file_name and $line_no not appended
	if ($eh->_LEVEL['SOURCE'] & $level) {
		$message .= sprintf("(0x%02x) %s\n", $level, $err_str);
	}
	elseif ($level==0) {
		$message = sprintf("%s\n", $err_str);
	}
	else {
		$message .= sprintf("(0x%02x): in %s line %s\n%s\n",
		                    $level, $file_name, $line_no, $err_str);
	}
	return $message;
}

AES_print(_("<h1 align=\"center\"><b>AlberT-EasySite Console</b></h1>"));
?>
