<?php
/* managePackages.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; version 2 of the License.              |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: managePackages.inc.php,v 1.3.2.2 2003/01/13 01:37:25 AlberT Exp $
*/


/**
 * Load plugins in AES main directory
 */
function AES_usePackage($pkg)
{
	global $AES_objects;

	/* loads package's plugins */
	$piDir = AES_SITE_PATH.'/packages/'.$pkg.'/plugins';
	$pluginDirs =& _AES_getPluginsDirName($piDir);
	//loads all plugins in "plugins" directory; they must contains a file 
	// "PLUGIN_NAME/AES_registerPlugin.inc.php"
	// otherwise will be ignored and added to AES_ignoredPlugins !
	foreach ($pluginDirs as $pluginDir) {
		//loads all plugins in "plugins" directory; each Plugin Dir must 
		// contains a file "AES_registerPlugin.inc.php"
		// otherwise will be ignored and added to AES_ignoredPlugins !
		$include = $piDir.'/'.$pluginDir.'/AES_registerPlugin.inc.php';
		$ret = include $include;
		if ($ret === TRUE) {
			AES_print( sprintf(_("Plugin file '%s/plugins/<b>%s</b>".
			                     "/AES_registerPlugin.inc.php' ".
			                     "<font color=\"red\">loaded</font>."), 
			                   AES_INST_PATH, $pluginDir) );
		}
		else {
			// this case should NOT happen, but ...
			AES_print( sprintf(_("Inclusion of plugin file '<b>%s' <font ".
			           "color=\"red\">failed</font>."), $include), E_WARNING);
		}
	}
}
?>
