<?php
$PSA_SCR=array(
    'Type'        =>    'mysql',                            // type of database
    'Host'        =>    'localhost',                        // database server to connect to
    'User'        =>    'phpuser',                          // username for database
    'Password'    =>    'php',                              // password for database
    'Database'    =>    'psa_db',                           // name of the database
    'Language'    =>    'en',                               // the default language for display
    'SiteName'    =>    'www.development.com',              // the name of the site
    'IncludePath' =>    dirname(__FILE__).'/../../metabase' // where to find the metabase files
);

$PSA_OPTS=array(
    'Tables'       =>   '#000099',              // Color you want for your tables
    'MenuFont'     =>   '#ffffff',              // Color of the font for menu items
    'DataFont'     =>   '#000099',              // Color of the font for the data
    'DataBack'     =>   '#ffffff',              // Color of the background for the data
    'ErrorFont'    =>   '#cc0000',              // Color of the font for error messages
    'ErrorBack'    =>   '#cccccc',              // Color of the background for error messages
    'AltRowColor'  =>   '#dfdfdf',              // Alternate Row color for tables
    'W3C'          =>   TRUE,                   // TRUE or FALSE for showing the W3C links
    'ShowSiteName' =>   TRUE                    // TRUE or FALSE to show site name at the top
);

/**************** SHOULD NOT NEED TO EDIT ANYTHING BELOW THIS LINE ****************/

require_once dirname(__FILE__).'/class.phpSecurityAdm.php';
require_once dirname(__FILE__).'/sessions.php';

$PSA_SYS = new phpSecurityAdm($PSA_SCR,$PSA_OPTS);
if(strlen($PSA_SYS->Error())){
    echo $PSA_SYS->Error();
    exit;
}

if(!isset($PSA_INSTALLING))
    session_start();

function securityHeader($charset='iso-8859-1',$PSA_OPTS=''){
    global $PSA_SYS;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//<?php echo strtoupper($PSA_SYS->LANGUAGE); ?>">
<html>
 <head>
  <title>phpSecurityAdm <?php echo $PSA_SYS->VERSION ?>: <?php echo $PSA_SYS->SITE_NAME ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $charset ?>">
  <style type="text/css">
   <!--
   .errormsg{
    font-family: sans-serif,arial,helvetica;
    font-size: 90%;
    color: <?php echo $PSA_OPTS['ErrorFont'] ?>;
    background-color: <?php echo $PSA_OPTS['ErrorBack'] ?>;
   }
   .headercell{
    font-family: sans-serif,arial,helvetica;
    font-size: 90%;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    background-color: <?php echo $PSA_OPTS['DataBack'] ?>;
   }
   .headercell h2{
    font-family: sans-serif,arial,helvetica;
    font-size: 175%;
    font-weight: bold;
    font-style: italic;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    background-color: <?php echo $PSA_OPTS['DataBack'] ?>;
   }
   .headercell a{
    font-family: sans-serif,arial,helvetica;
    text-decoration: none;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    background-color: <?php echo $PSA_OPTS['DataBack'] ?>;
   }
   .menucell a{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['MenuFont'] ?>;
    text-decoration: none;
    font-weight: bold;
    font-size: 90%;
    background-color: <?php echo $PSA_OPTS['Tables'] ?>;
   }
   .menucell a:hover{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['Tables'] ?>;
    background-color: <?php echo $PSA_OPTS['MenuFont'] ?>;
   }
   .maincell{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    font-size: 90%;
    background-color: <?php echo $PSA_OPTS['DataBack'] ?>;
   }
   .maincell td{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    font-size: 80%;
    background-color: <?php echo $PSA_OPTS['DataBack'] ?>;
   }
   .maincell a{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['DataFont'] ?>;
    font-weight: bold;
    padding: 2px;
   }
   .maincell a:hover{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['DataBack'] ?>;
    background-color: <?php echo $PSA_OPTS['DataFont'] ?>;
   }
   .versionnum{
    font-family: sans-serif,arial,helvetica;
    color: <?php echo $PSA_OPTS['MenuFont'] ?>;
    font-size: 75%;
    background-color: <?php echo $PSA_OPTS['Tables'] ?>;
   }
   -->
  </style>
 </head>

 <body style="background-color: <?php echo $PSA_OPTS['DataBack'] ?>; color: <?php echo $PSA_OPTS['DataFont'] ?>;">
<?php
}

function securityFooter(){
?>
 </body>
</html>
<?php
}

?>
