<?php
/*
    This program is free software; you can redistribute it and/or modify it under the terms of
    the GNU General Public License as published by the Free Software Foundation; either version
    2 of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details. (Found in the LICENSE file.)

    You should have received a copy of the GNU General Public License along with this program;
    if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA 02111-1307 USA
*/
    if(!isset($PSA_PATH))
        $PSA_PATH=dirname(__FILE__);

    require_once $PSA_PATH.'/include/config.php';
    
    // To use in a templated system, we may need to have output strings returned, do this with the ob_* functions
    ob_start();
?>
<table cellpadding=10 cellspacing=0 border=0 width="700">
 <tr>
  <td colspan="2" align="center" class="headercell">
<?php
    if($PSA_OPTS['ShowSiteName'])
        echo '<h2>[<a href="http://'.$PSA_SYS->SITE_NAME.'/" target="mainsite">'.$PSA_SYS->SITE_NAME.'</a>]</h2>'."\n";
?>
   <p class="headercell" align="left">
    [<a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=main"><?php echo _("Login"); ?></a>]
    [<a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=logout"><?php echo _("Logout"); ?></a>]
   </p>
  </td>
</tr>
<tr>
  <td valign="top" class="menucell" style="background-color: <?php echo $PSA_OPTS['Tables'] ?>;">
   <a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=users"><?php echo _("Users"); ?></a><br>
   <a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=profiles"><?php echo _("Profiles"); ?></a><br>
   <a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=pages"><?php echo _("Structure"); ?></a><br>
   <a href="<?php echo $_SERVER['PHP_SELF'] ?>?PSA_SEC=settings"><?php echo _("Configuration"); ?></a><br>
   <a href="phpSecurityAdm.html" target="docs"><?php echo _("Documentation"); ?></a>
   <p><a href="http://validator.w3.org/check/referer" target="validatehtml"><img border="0" src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!" height="31" width="88"></a></p>
   <p><a href="http://jigsaw.w3.org/css-validator/" target="validatecss"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"></a></p>
   <span class="versionnum">phpSecurityAdm <?php echo $PSA_SYS->VERSION ?></span>
  </td>
  <td class="maincell" width="550" valign="top">
<?php
    if($PSA_SYS->isLoggedIn() && $PSA_SYS->isAdmin($_SESSION['PSA_psaun'])){
        switch($_GET['PSA_SEC']){ // admin users
            case 'main':
                include $PSA_PATH.'/include/main.php';
                break;
            case 'users':
                include $PSA_PATH.'/include/users.php';
                break;
            case 'user_add':
                include $PSA_PATH.'/include/user_add.php';
                break;
            case 'user_edit':
                include $PSA_PATH.'/include/user_edit.php';
                break;
            case 'user_delete':
                include $PSA_PATH.'/include/user_delete.php';
                break;
            case 'user_edit_connections':
                include $PSA_PATH.'/include/user_edit_connections.php';
                break;
            case 'user_edit_details':
                include $PSA_PATH.'/include/user_edit_details.php';
                break;
            case 'user_edit_rights':
                include $PSA_PATH.'/include/user_edit_rights.php';
                break;
            case 'profiles':
                include $PSA_PATH.'/include/profiles.php';
                break;
            case 'profile_add':
                include $PSA_PATH.'/include/profile_add.php';
                break;
            case 'profile_edit':
                include $PSA_PATH.'/include/profile_edit.php';
                break;
            case 'profile_delete':
                include $PSA_PATH.'/include/profile_delete.php';
                break;
            case 'pages':
                include $PSA_PATH.'/include/pages.php';
                break;
            case 'page_add':
                include $PSA_PATH.'/include/page_add.php';
                break;
            case 'page_edit':
                include $PSA_PATH.'/include/page_edit.php';
                break;
            case 'page_delete':
                include $PSA_PATH.'/include/page_delete.php';
                break;
            case 'settings':
                include $PSA_PATH.'/include/settings.php';
                break;
            case 'logout':
                include $PSA_PATH.'/include/logout.php';
                break;
            default:
                include $PSA_PATH.'/include/main.php';
        }
    }elseif($PSA_SYS->isLoggedIn()){
        $id=$_SESSION['PSA_psaun'];
        switch($_GET['PSA_SEC']){ // normal users
            case 'main':
                include $PSA_PATH.'/include/main.php';
                break;
            case 'users':
                include $PSA_PATH.'/include/user_edit.php';
                break;
            case 'user_edit_details':
                include $PSA_PATH.'/include/user_edit_details.php';
                break;
            case 'user_edit_connections':
                include $PSA_PATH.'/include/user_edit_connections.php';
                break;
            case 'logout':
                include $PSA_PATH.'/include/logout.php';
                break;
            default:
                include $PSA_PATH.'/include/main.php';
        }
    }else{
        include $PSA_PATH.'/include/main.php';
    }
?>
  </td>
 </tr>
</table>
<?php
    // save the page output.
    //$PSA_OUTPUT=str_replace('&amp;nbsp;','&nbsp;',str_replace('&','&amp;',ob_get_contents()));
    $PSA_OUTPUT=ob_get_contents();

    // Set the current domain that gettext will use
    bindtextdomain('psa', dirname(__FILE__).'/lang');
    textdomain('psa');
    
    // clear the buffer and turn of buffering
    ob_end_clean();

    // Outputs the begining HTML with the styles, title and body tags
    securityHeader('iso-8859-1',$PSA_OPTS);

    // This is the actual contents of the display without the start and end HTML tags. You can use this in your
    // templated framework, but you may have to copy the styles out of the config.php file in the securityHeader
    // function for your display to look as it does here.
    
    // The last echo statement is after all the gettext translations.
    echo $PSA_OUTPUT;

    // Outputs the ending HTML
    securityFooter();
?>
