<?php
/* parseTemplate.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: parseTemplate.inc.php,v 1.6.2.2 2003/01/13 01:37:25 AlberT Exp $
 */

/*******************************************************************\
**
**      Class _parseTemplate:
**
**  parse a template file retriving the 'objects' embedded
**  and calls the proper PlugIn for each object
**       (if PlugIn exists!)
**
\*******************************************************************/

class _parseTemplate
{
	var $_theme = NULL;

	// LEGGE IL CONTENUTO DI UN FILE E LO ASSEGNA AD UNA VARIABILE
	//
	// READS A FILE AND PUTS THE CONTENT IN A VARIABLE
	function _importFile($fp)
	{
		$content = NULL;

		$file = file($fp);
		for ($i=0; $i<count($file); ++$i) {
			$content .= $file[$i];
		}

		return $content;
	}

	// GENERA UN ARRAY CONTENENTE L'HTML NELLE ENTRATE PARI E GLI
	//  OGGETTI DA SOSTITUIRE IN QUELLE DISPARI.
	//
	// RETURNS AN ARRAY WITH HTML IN EVEN ENTRIES, THE OBJECTS
	//  TO BE SUBSTITUED IN THE OTHERS.
	function _parseContent($string, $separator=AES_TEMPLATE_STRING_SEPARATOR)
	{
		$vector = array();
		$name   = NULL;
		$stParm = NULL;
		global $AES_parserActive, $AES_objInstanceCount;

		// Divide html from objects
		$vector = explode($separator, $string);
		// Nelle enrate dispari dell'array ho gli "oggetti" ...
		//
		// In odd entries we get the "objects" ...
		for ($i=0; $i<count($vector); $i+=2) {
			$obj = NULL;
			// print HTML
			echo $vector[$i];
			if (!empty($vector[$i+1])) {
				$obj = $vector[$i+1];
			}
			$obj = $this->_getObj($obj);
			if (defined($obj['name'])) {
				$name   = $obj['name'];
				// a string like:  'par1', 2, False, "par$i"
				$stParm = $obj['stParm'];
				if ($name == 'repeatEnd')
					$AES_parserActive = TRUE;
				if (!$AES_parserActive) {
					echo AES_TEMPLATE_STRING_SEPARATOR.$vector[$i+1].
					     AES_TEMPLATE_STRING_SEPARATOR;
					continue;
				}
				AES_doCallback($name, $stParm);
			}
		}

		return TRUE;
	}


	// RESTITUISCE NOME E ARGOMENTI PER UN DATO "OGGETTO"
	//
	// GET NAME AND ARGS FOR A GIVEN "OBJECT"
	function _getObj($obj)
	{
		$ret = array();

		$ob = explode(AES_TEMPLATE_OBJ_SEPARATOR, $obj);
		$ret['name']   = $ob[0];
		//echo $ob[1];
		if (empty($ob[1]))
			$ret['stParm'] = NULL;  //an array made of parameters
		else
			$ret['stParm'] = str_replace( "'", '', array_map('trim',
			                             explode(',', substr($ob[1], 1, -1))));

		return $ret;
	}

	function getParsed($file, $separator=AES_TEMPLATE_STRING_SEPARATOR)
	{
		$content = '';

		if (@is_readable($file)) {
			$content = $this->_importFile($file);
			$this->_parseContent($content, $separator);
		}
		else {
			AES_print( sprintf(_("File '%s' does not exist or is not ".
			                     "readable by webserver !!!"), $file) );
			return FALSE;
		}

		return TRUE;
	}

	// Include an existent file, otherwise include a default file
	function _fileInclude($file)
	{
		if (@is_readable($file)) {
			include $file;
		}
		elseif (@is_readable($this->_defaultPage)) {
			AES_print( sprintf(_("File'<b>%s</b>' unreadable... ".
			                     "including default!"), $file), E_WARNING );
			include $this->_defaultPage;
		}
		else {
			AES_print( sprintf(_("Can't open default page: '<b>%s</b>'. ".
			           "Is it present and readable by the webserver?"),
			           $this->_defaultPage), E_ERROR);
			return FALSE;
		}

		return TRUE;
	}
}
?>
