<?php
/* registerPlugin.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: registerPlugins.inc.php,v 1.3.2.1 2003/01/13 01:37:25 AlberT Exp $
 */

// Plugin definition
class AES_plugin
{
	var $name         = '';  // name of the pluig
	var $objects      = '';  // array of objects the plugin act to
	var $author       = '';  // author
	var $version      = '';  // version
	var $description  = '';  // a brief description
}

// Array for all registered plugins
$AES_registeredPlugins = array();

// Initialize registered plugins array
$plugin = NULL;
for ($i = 0; $i < AES_MAX_PLUGINS; $i++) {
	$plugin = new AES_plugin;
	$plugin->name = -1;
	$AES_registeredPlugins[$i] = $plugin;
}
unset($plugin);


///////////////////////////////////////////////////////////////////////////////
//
// function AES_registerPlugin($name, $objects, $author, $ver, $description)
//
///////////////////////////////////////////////////////////////////////////////
//
// Adds a callback address
//
///////////////////////////////////////////////////////////////////////////////
//
// Parameter:
//  $object   - object to call function upon
//  $callback - function to set for callback
//  $order    - position for the callback
//
///////////////////////////////////////////////////////////////////////////////
//
// Return value:
//  FALSE - error
//  TRUE - ok
//
///////////////////////////////////////////////////////////////////////////////
//
// Global references:
//  $AES_registeredPlugins, $AES_disabledPlugins
//
///////////////////////////////////////////////////////////////////////////////

function AES_registerPlugin($name, $objs, $author='', $ver='', $desc='', $ob)
{

	global $AES_registeredPlugins, $AES_disabledPlugins;
	global $obStart;

	if ($ob === TRUE) {                     // if any plugin starts output this
		$obStart = TRUE;                    //  is necessary to allow others to
	}                                       //  set cookies and headers
	if (@in_array($name, $AES_disabledPlugins, TRUE)) {
		return FALSE;
	}
	if (''==$author)
		$author = 'Emiliano Gabrielli <AlberT@SuperAlberT.it>';
	// find empty slot for plugin
	for ($i=0; $i < AES_MAX_PLUGINS; ++$i) {
		$slot = $AES_registeredPlugins[$i];
		if ($slot->name == -1) {                // found free slot...
			//... initialize it
			$slot->name        = $name;
			$slot->objects     = $objs;         // an array
			$slot->author      = $author;
			$slot->version     = $ver;
			$slot->description = $desc;
			// re-assign slot
			$AES_registeredPlugins[$i] = $slot;
			// inizialize the object
			foreach ($objs as $obj) {
				AES_inizializeObj($obj, 'AES_'.$obj);
				//echo "oggetto: '$obj' - 'AES_$obj'<br>\n";
			}
			// return success
			return TRUE;
		}
	}
	// no free slot found, return error
	return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
//
// function AES_removePlugin($name)
//
///////////////////////////////////////////////////////////////////////////////
//
// Removes a plugin
//
///////////////////////////////////////////////////////////////////////////////
//
// Parameter:
//  $name - name of the plugin
//
///////////////////////////////////////////////////////////////////////////////
//
// Return value:
//  FALSE - error
//  TRUE - ok
//
///////////////////////////////////////////////////////////////////////////////
//
// Global references:
//  $AES_registeredPlugins
//
///////////////////////////////////////////////////////////////////////////////

function AES_removePlugin($name)
{
	global $AES_registeredPlugins;

	// find slot for given plugin
	for ($i = 0; $i < AES_MAX_CALLBACKS; ++$i) {
		$slot = $AES_registeredPlugins[$i];
		if ($slot->name == $name) {            // found slot...
			//... kill it
			$slot->name = -1;
			unset($slot->objects);
			unset($slot->author);
			unset($slot->version);
			unset($slot->description);
			// re-assign slot
			$AES_registeredPlugins[$i] = $slot;
			// return success
			return TRUE;
		}
	}
	// slot not found, return error
	return FALSE;
}

function AES_inizializeObj($name, $class)
{
	global $AES_objects;

	if (class_exists($class) && defined($name)) {
		$inst = @constant('AES_MAX_'.$name.'_INSTANCES');
		for ($i=1; $i <= min(AES_MAX_OBJ_INSTANCES , $inst); ++$i) {
			$AES_objects[$name][$i] = new $class;
			//var_dump($AES_objects[$name][$i]);
		}
	}
	return TRUE;
}
?>
