<?php
/* dbFunctions.inc.php
*
* +----------------------------------------------------------------------+
* |                                                                      |
* | AlberT-EasySite: Web Site Management System                          |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Copyleft (c) SuperAlberT.it                                          |
* +----------------------------------------------------------------------+
* | This program is free software. You can redistribute it and/or modify |
* | it under the terms of the GNU General Public License as published by |
* | the Free Software Foundation; either version 2 of the License.       |
* +----------------------------------------------------------------------+
* | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
* |                                                                      |
* +----------------------------------------------------------------------+
*
* $Id: dbFunctions.inc.php,v 1.2 2002/06/08 14:26:27 AlberT Exp $
*/


///////////////////////////////////////////////////

function db_pConnect($host,$port,$dbname,$user,$passwd,$dbms)
{
	if ($dbms=='pg') {
		return pg_pConnect("dbname=$dbname port=$port host=$host user=$user password=$passwd");
	}
	elseif ($dbms=='ms') {
		$con=sybase_pconnect($host,$user,$passwd);
		return sybase_select_db($dbname,$con);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

///////////////////////////////////////////////////

function db_Connect($host, $port,$dbname,$user,$passwd,$dbms)
{
	if ($dbms=='pg') {
		return pg_pconnect ("dbname=$dbname port=$port host=$host user=$user password=$passwd");
	}
	elseif ($dbms=='ms') {
		$con=sybase_pconnect($host,$user,$passwd);
		return sybase_select_db($dbname,$con);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

/////////////////////////////////////////////////

function db_Result($result,$i,$field,$dbms)
{
	if ($dbms=='pg') {
		return pg_Result($result,$i,$field);
	}
	elseif ($dbms=='ms') {
		return sybase_Result($result,$i,$field);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

///////////////////////////////////////////////////

function db_NumRows($result,$dbms)
{
	if ($dbms=='pg') {
		if (!$result) { return ''; }
		return pg_NumRows($result);
	}
	elseif ($dbms=='ms') {
		if (!$result) { return ''; }
		return sybase_num_rows($result);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

///////////////////////////////////////////////////

function db_FetchArray($result,$row,$dbms)
{
	if ($dbms=='pg') {
		if (!$result) { return ''; }
		return pg_Fetch_Array($result,$row);
	}
	elseif ($dbms=='ms') {
		if (!$result) { return ''; }
		sybase_data_seek($result, $row);
		return sybase_fetch_array($result);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

///////////////////////////////////////////////////

function db_NumFields($result,$dbms)
{
	if ($dbms=='pg') {
		if (!$result) { return ''; }
		return pg_NumFields($result);
	}
	elseif ($dbms=='ms') {
		if (!$result) { return ''; }
		return sybase_num_fields($result);

	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

///////////////////////////////////////////////////

function db_Exec($conn,$query,$dbms)
{
	if ($dbms=='pg') {
		return pg_Exec($conn,$query);
	}
	elseif ($dbms=='ms') {
		return sybase_query($query,$conn);

	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

////////////////////////////////////////////////////

function db_Close($conn,$dbms)
{
	if ($dbms=='pg') {
		return pg_Close($conn);
	}
	elseif ($dbms=='ms') {
		return sybase_close($conn);
	}
	else {
		echo 'ERRORE SPECIFICARE IL TIPO DI DBMS';
	}
}

////////////////////////////////////////////////////
?>
