<?php
/* _adminFunctios.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: _adminTools.inc.php,v 1.2.2.1 2002/12/01 18:50:26 AlberT Exp $
 */

class AES_cfgEditor
{
	var $_cfgFile;

	function AES_cfgEditor($cfgFile=NULL)
	{
		$this->_cfgFile = $cfgFile;
		if ($cfgFile===NULL) {
			$this->_cfgFile = dirname(__FILE__).'/../config.inc.php';
		}

		return TRUE;
	}

	function getVars()
	{
		$vars = array();
		$var = $value = $regex = '';

		$lines = file($this->_cfgFile)
			or die(printf(_("Fatal: unable to open %s for reading!<br>"), $this->_cfgFile));
			foreach ($lines as $line) {
			$match = NULL;
			/* cut out comments */
			$line = eregi_replace('^[[:blank:]]*#.*$', NULL, $line);
			$line = eregi_replace('^(.+;[[:blank:]]*)#.*$', "\\1", $line);
			$line = eregi_replace('^(.+;[[:blank:]]*)//.*$', "\\1", $line);
			$regex = '^[[:blank:]]*\$([^=]+)=([[:blank:]]*array[[:blank:]]*\([^)]+[[:blank:]]*\))[[:blank:]]*;';
			if (eregi($regex, $line, $match) && !empty($match)) {
				$var = trim($match[1]);
				$value = trim($match[2]);
				eval('$vars[$var] = '.$value.';');
				continue;
			}
			if (eregi('^[[:blank:]]*\$([^=]+)=([^;]+)', $line, $match) && !empty($match)) {
				$var = trim($match[1]);
				$value = trim($match[2]);
				$vars[$var] = $value;
			}
		}

		return $vars;
	}

	function writeVars(&$vars)
	{
		//we don't care locks becouse only one administrator each time will be allowed
		$lines = @file($this->_cfgFile)
			or die(printf(_("Fatal: unable to open %s for reading!<br>"), $this->_cfgFile));
		foreach ($lines as $line) {
			$match = NULL;
			ereg('^([[:blank:]]*)(\$[^=]+)(=[[:blank:]]*)([^;]+)(.+)$', $line, $match);
			if (isset($match[0]) && isset($match[1]) && isset($match[2]) && isset($vars[trim($match[2])])) {
				$new[] = $match[1].$match[2].$match[3].$vars[trim($match[2])].$match[5];
			}
			else {
				$new[] = $line;
			}
		}
		$new = implode('', $new);
		$fp = @fopen($this->_cfgFile, 'wb')
			or die(printf(_("Fatal: unable to open %s for writing!<br>"), $this->_cfgFile));
		// yea .. we are a bit paranoid !
		flock($fp, LOCK_EX, TRUE);
		fwrite($fp, $new, strlen($new));
		flock($fp, LOCK_UN, TRUE);
		fclose($fp);

		return TRUE;
	}

	function getConsts()
	{
		$consts = array();
		$const = $value = '';
		$lines = file($this->_cfgFile)
			or die(printf(_("Fatal: unable to open %s for reading!<br>"), $this->_cfgFile));
		foreach ($lines as $line) {
			$match = NULL;
			/* cut out comments */
			$line = eregi_replace('^[[:blank:]]*#.*$', NULL, $line);
			$line = eregi_replace('^(.+;[[:blank:]]*)#.*$', "\\1", $line);
			$line = eregi_replace('^(.+;[[:blank:]]*)//.*$', "\\1", $line);
			$regex = "^[[:blank:]]*define[[:blank:]]*\([[:blank:]]*[']([^']+)['][[:blank:]]*,[[:blank:]]*(.+)[[:blank:]]*\)[[:blank:]]*;";
			ereg($regex, $line, $match);
			if (!empty($match)) {
				$const = trim($match[1]);
				$value = trim($match[2]);
				$consts[$const] = $value;
			}
		}

		return $consts;
	}

	function writeConsts(&$consts)
	{
		$regex = "^([[:blank:]]*define[[:blank:]]*\([[:blank:]]*')([^']+)('[[:blank:]]*,[[:blank:]]*)(.+)([[:blank:]]*\)[[:blank:]]*;.*)$";
		//we don't care locks becouse only one administrator each time will be allowed
		$lines = @file($this->_cfgFile)
			or die(printf(_("Fatal: unable to open %s for reading!<br>"), $this->_cfgFile));
		foreach ($lines as $line) {
			$match = NULL;
			ereg($regex, $line, $match);
			if (isset($match[0]) && isset($match[1]) && isset($match[2]) && isset($consts[trim($match[2])])) {
				$new[] = $match[1].$match[2].$match[3].$consts[trim($match[2])].$match[5];
			}
			else {
				$new[] = $line;
			}
		}
		$new = implode('', $new);
		$fp = @fopen($this->_cfgFile, 'wb')
			or die(printf(_("Fatal: unable to open %s for reading!<br>"), $this->_cfgFile));
		// yea .. we are a bit paranoid !
		flock($fp, LOCK_EX, TRUE);
		fwrite($fp, $new, strlen($new));
		flock($fp, LOCK_UN, TRUE);
		fclose($fp);

		return TRUE;
	}

	function valid_AESPath()
	{
		$vars = $this->getVars();
		$site = dirname(__FILE__);
		$site = ereg_replace('^(.*)/admin$', "'\\1'", $site);
		$path = ereg_replace('AES_SITE_PATH', $site, $vars['AES_AES_PATH']);
		echo eval('$path = '.$path.'; ');
		if (isset($path) && is_readable($path)) {
			return $path;
		}

		return FALSE;
	}
}
?>
