<?php
/* auth.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: auth.inc.php,v 1.2.2.2 2003/02/07 21:54:09 AlberT Exp $
 */

/** AES_auth()
 *
 *  basic auth function, it checks for name, pwd and IP
 *
 *  @param $timeout minutes after witch session expires
 */
function AES_auth($timeout=5)
{
	session_start();
	if ( (isset($_POST['AES_admin_usr']) && isset($_POST['AES_admin_pwd'])) &&
		 _AES_isValidUser($_POST['AES_admin_usr'], $_POST['AES_admin_pwd']) ) {

		$_SESSION['AES_AUTH_U']    = $_POST['AES_admin_usr'];
		$_SESSION['AES_AUTH_P']    = $_POST['AES_admin_pwd'];
		$_SESSION['AES_AUTH_LAST'] = time();
		$_SESSION['AES_AUTH_IP']   = $_SERVER['REMOTE_ADDR'];
	}

	if ( (isset($_SESSION['AES_AUTH_IP']) && $_SESSION['AES_AUTH_IP'] !== NULL && $_SESSION['AES_AUTH_IP'] !== $_SERVER['REMOTE_ADDR']) ||
	     (isset($_SESSION['AES_AUTH_LAST']) && $_SESSION['AES_AUTH_LAST'] !== NULL && (time() - $_SESSION['AES_AUTH_LAST'] > $timeout*60) ) ||
	     (isset($_POST['AUTH_logout']) && isset($_SESSION['AES_AUTH_U']) && $_SESSION['AES_AUTH_U']!==NULL) ) {

		$_SESSION['AES_AUTH_U']    = NULL;
		$_SESSION['AES_AUTH_P']    = NULL;
		$_SESSION['AES_AUTH_LAST'] = NULL;
		$_SESSION['AES_AUTH_IP']   = NULL;
	}

	if ( isset($_SESSION['AES_AUTH_U']) && $_SESSION['AES_AUTH_U'] !== NULL) {
		$_SESSION['AES_AUTH_LAST'] = time();
?>
		<form method="POST" enctype="application/x-www-form-urlencoded"> 
			<input type="hidden" name="AUTH_logout" value="logout">
			<table width="140" border="0" align="left" bgcolor="#dddddd">
			<tr valign="center">
				<td><?php echo _("Hello"); ?></td>
				<td><i><b><?php echo $_SESSION['AES_AUTH_U']; ?></i></b></td>
				<td>&nbsp;&nbsp;<input type="submit" alt=<?php echo _("'logout'"); ?> align="top" value=<?php echo _("'logout'"); ?>></td>
			</tr>
			</table>
		</form>
<?php
		return TRUE;
	}
?>
	<form method="POST" enctype="application/x-www-form-urlencoded">
		<table width="140" border="0" align="left" bgcolor="#dddddd">
		<tr valign="center">
			<td>&nbsp;<?php echo _("User"); ?>:</td>
			<td><input type="text" name="AES_admin_usr" size="10" maxlength="12" alt="AES_admin_usr" tabindex="1" align="top"></td>

			<td>&nbsp;<?php echo _("Password"); ?>:</td>
			<td><input type="password" name="AES_admin_pwd" size="10" maxlength="12" alt="AES_admin_pwd" tabindex="2" align="top"></td>
			<input type="hidden" name="enter" value="enter">
			<td>&nbsp;&nbsp;<input type="submit" alt=<?php echo _("'enter'"); ?> align="top" value=<?php echo _("'enter'"); ?>></td>
		</tr>
		</table>
	</form>
<?php
	return FALSE;
}

function _AES_isValidUser($u, $p)
{
	if (eregi('^[[:alnum:]]+$', $u) && eregi('^[[:alnum:]]+$', $p)) {
		if ($u === AES_ADMIN_U && $p === AES_ADMIN_P) {
			return TRUE;
		}
	}
	else {
		return FALSE;
	}
}

//var_dump($GLOBALS['_SESSION']);
?>
