<?php
/* index.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: index.php,v 1.16.2.5 2003/02/17 21:46:55 AlberT Exp $
 */

// tells AES.php we are in admin module, so it can return before start
// parsing template and performing some resources comsuming tasks
define('AES_ADMIN', TRUE);

ob_start();
define('AES_SITE_PATH', dirname(__FILE__).'/..');

require_once(AES_SITE_PATH.'/AES/lib/gettext_replacer.inc.php');
// Set language to user's one
if (is_array($_SERVER) && array_key_exists('HTTP_ACCEPT_LANGUAGE', $_SERVER)) {
	$lang = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
}
if (isset($_COOKIE['AES_lang']) || !empty($_COOKIE['AES_lang'])) {
	$lang = $_COOKIE['AES_lang'];
}
if (isset($_GET['lang'])) {
	$lang = $_GET['lang'];
}
if (!isset($lang))
	$lang = 'en';
putenv('LANG='.$lang);
if (FALSE === setlocale(LC_ALL, $lang))
	$langErr = TRUE;
// Specify location of translation tables
bindtextdomain('admin', dirname(__FILE__).'/locale');
textdomain('admin');


require dirname(__FILE__).'/_adminTools.inc.php';

$ed =& new AES_cfgEditor();
$path = $ed->valid_AESPath();

// if AES_AES_PATH is not valid ask the user!
if(FALSE===$path) {
	echo _("<h1>Your <font color='red'>$AES_AES_PATH</font> variable is not valid!</h1> ").
	     _("<h3>Please edit the file <b>config.inc.php</b> by hand and set it to the true path to the directory ").
	     _("containig the file <b>AES.php</b> (ask your sysadmin if you don`t know what it is).<br></h3>")."\n";
	exit;
}
if (FALSE === include(AES_SITE_PATH.'/config.inc.php')) {
	include($path);
	echo _("The file <b>confing.inc.php</b> contains some syntax errors.<br>").
	     _("Please go back and control your settings. Keep in mind that the you have to respect PHP syntax <br>")."\n";
}

include_once dirname($path).'/handleErrors.inc.php';
if (defined('AES_DEBUG') && AES_DEBUG === TRUE) {
	AES_print('<br><div align="center">AES '.AES_VERSION.': <b>'._("DEBUG MODE ENABLED").'</b><br>'.
	'<font size="-2">('._("edit config.inc.php to disable").')</font></div>');
}
if (isset($langErr))
	AES_print('Failed setting language to '.$lang, E_WARNING);

require dirname(__FILE__).'/auth.inc.php';

require dirname($path).'/functions.inc.php';
$AES_SELF = $_SERVER['PHP_SELF'];

$css = (FALSE===strpos($_SERVER['HTTP_USER_AGENT'], 'Mozilla/4.7')) ? 'AESadmin.css' : 'AESadmin_NS.css';
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
<head>
	<title><?php echo _("AlberT-EasySite Configuration & Admin Panel"); ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="<?php echo $css; ?>" rel="StyleSheet" type="text/css" media="screen">
</head>
<body bgcolor="#ffffff" vlink="#555555" link="#000000" alink="#dddddd">
<table border="0" align="center" bgcolor="#cccccc" class="underborder">
  <tr>
    <td rowspan="2" align="left"><img src="enter.jpg" width="83" height="105"></td>
    <th width="267" nowrap><div align="center">
	  <b><a href="<?php echo AES_SITE_URL; ?>/" name="<?php echo AES_SITE_URL; ?>/">AlberT-EasySite
        <?php echo _("Configuration & Admin Panel"); ?></a></b>
      </div>
	</th>
  </tr>
  <tr>
    <td>
      <?php $_OK = AES_auth(); ?>
    </td>
  </tr>
</table>
<br>
<?php
if ($_OK !== TRUE) {
	echo '</body></html>';
	exit;
}
?>
<table width="98%" border="0" align="center" cellpadding="4" bgcolor="#cccccc" class="underborder">
	<tr valign="top">
    <td valign="top" nowrap class="underborder">
      <dl>
				<dt><b>AlberT-EasySite</b></dt>
					<dd><u><a href="<?php echo $AES_SELF ;?>"><?php echo _("edit config file"); ?></a></u></dd>
				<dt><b><?php echo _("modules"); ?></b></dt>
					<dd><u><a href="<?php echo $AES_SELF.'?act=cache' ;?>">cache</a></u></dd>
					<dd><u><a href="#">auth</a></u></dd>
					<dd><u><a href="#">dbal</a></u></dd>
				<dt><b><?php echo _("plugins"); ?></b></dt>
					<dd><u><a href="#">AlberT-counter</a></u></dd>
				<dt><b><?php echo _("packages"); ?></b></dt>
					<dd><u><a href="<?php echo $AES_SELF.'?act=zb_news' ;?>">zb_news</a></u></dd>
					<dd><u><a href="<?php echo $AES_SELF.'?act=news' ;?>">news</a></u></dd>
					<dd><u><a href="#">poll</a></u></dd>
					<dd><u><a href="#">articles</a></u></dd>
					<dd><u><a href="#">forum</a></u></dd>
			</dl>
		</td>
		<td valign="top">
			<?php
			if (isset($_GET['act']) || isset($_POST['act'])) {
				$domain = textdomain(NULL);
				$act = (isset($_GET['act'])) ? $_GET['act'] : $_POST['act'];
				switch ($act) {
					case 'cache':
						require AES_INST_PATH.'/AES/modules/cache/_AES_panel.inc.php';
						break;
					case 'zb_news':
						require AES_SITE_PATH.'/packages/zb_news/admin/_AES_panel.inc.php';
						break;
					case 'news':
						require AES_SITE_PATH.'/packages/news/admin/_AES_panel.inc.php';
						break;
					default:
						break;
				}
				bindtextdomain($domain, AES_INST_PATH.'/AES/locale');
				textdomain($domain);
			}
			else {
				require dirname(__FILE__).'/_AES_panel.inc.php';
			}
			?>
		</td>
	</tr>
</table>
</body>
</html>
