<?php

/***********************************************************************************
	
	EXAMPLE: 

<?php

	include ('./Classi/OOimage.inc.php');
	
	$imm = new OOimage('image.jpg');
	
		
	if ($imm->ExistImage()) {
		echo "<p>image name : " . $imm->GetImageName() . "</p>\n";
		echo "<p>image height : " . $imm->GetimageHeight() . "</p>\n";
		echo "<p>image whidth : " . $imm->GetimageWidth() . "</p>\n";
		echo "<p>image path : " . $imm->GetimagePath() . "</p>\n";
		echo "<p>image whidth : " . $imm->GetimageSize() . "</p>\n";
		echo "<p>image dimension : " . $imm->GetimageDimension() . "</p>\n";
		echo "<p>image type : " . $imm->GetimageType() . "</p>\n";
		if ($imm->ExistThumb()) {
			echo "<p>Existent thumb : ". $imm->GetThumbName() . "</p><br>";
		} else {
			$imm->MakeThumb();
			if ($imm->ExistThumb())
				echo "<p>Created thumb : ". $imm->GetThumbName() . "</p><br>";
		}
		echo $imm->HtmlThumbImage();			
	} else {
		echo "<p>Do not exist!</p>";
	}
?>
	
**************************************************************************************/

class OOimage {
	var $name;
	var $directory;
	var $path;
	var $width, $height, $type, $dimension;
	var $prefix;
	var $exist;

	function OOimage ($name = "",$directory = "./images") {
		if (!is_dir ($directory))
			mkdir ($directory, 0775);	
			
			$this->path = $directory."/".$name;
				
        if (file_exists ($this->path)) {
			$this->name       	= $name;
			$this->directory  	= $directory;
			$this->exist	    = TRUE;
			$size        		= GetImageSize($this->path);
			$this->width  		= $size [0];
			$this->height		= $size [1];
			$this->type       	= $size [2];
			$this->dimension 	= $size [3];
		} else {
			$this->name 		= $name;
			$this->directory 	= $directory;
			$this->exist    	= FALSE;
			$this->width	 	= 0;
			$this->heigth   	= 0;
			$this->type      	= "";
		}
	}

	function GetImageName () {
		return $this->name;
	}

	function GetImageHeight () {
		return $this->height;
	}

	function GetImagePath () {
		return $this->path;
	}
		
	function GetImageWidth () {
		return $this->width;
	}
	
	function GetImageSize () {
		$size = filesize ($this->path);
		return $size;
	}
	
	function GetImageType () {
		switch ($this->type) {
			case 1 :
        		return "GIF";
      		case 2 :
        		return "Jpeg";
      		case 3 :
        	 	return "PNG";
        	case 4 :
        		return "SWF";
        	case 5 :
        		return "PSD";
        	case 6 :
        		return "BMP";
        	case 7 :
        		return "TIFF_II";
        	case 8 :
        		return "TIFF_MM";
        	case 9 :
        		return "JPC";
        	case 10 :
        		return "JP2";
        	case 11 :
        		return "JPX";	
      	}
      }

   
	function GetImageDimension () {
		return $this->dimension;
	}	
	
	function ExistThumb ($prefix = 'thb') {
		if (file_exists ($this->directory."/$prefix".$this->name)) {
			$this->prefix = $prefix; 
			return TRUE;
		} else 
			return FALSE;
	}
	
	function ExistImage () {
		return $this->exist;
	}
	
    function MakeThumb ($dimension = 100, $quality = 70, $prefix = "thb") {
        
        $this->prefix = $prefix;
        $newHeight   = $dimension;
		$newWidth    = $dimension;
		
   		if ($im = $this->ReadImageFromFile($this->path, $this->type)) {
      		if ($newHeight && ($this->width < $this->height)) {
         		$newWidth = ($newHeight / $this->height) * $this->width;
      		} else {
         		$newHeight = ($newWidth / $this->width) * $this->height;
      		}
      		if (function_exists("ImageCreateTrueColor")) {
         		$im2 = ImageCreateTrueColor($newWidth,$newHeight);
      		} else {
         		$im2 = ImageCreate($newWidth,$newHeight);
      		}
      		if (function_exists("ImageCopyResampled")) {
          		ImageCopyResampled($im2,$im,0,0,0,0,$newWidth,$newHeight,$this->width,$this->height);
      		} else {
          		ImageCopyResized($im2,$im,0,0,0,0,$newWidth,$newHeight,$this->width,$this->height);
      		}
      		if ($this->WriteImageToFile($im2, $this->directory."/".$this->prefix.$this->name, $this->type, $quality)) {
          		return true;
      		} else {
      			return false;
      		}
      	}
     }
     
    function GetThumbName () {
    	$result = $this->prefix . $this->GetImageName();
        return $result;
    }
    
    function HtmlThumbImage () {
    	$html = "<a href=\"".$this->path."\"> <img src=\"".$this->directory."/".$this->GetThumbName()."\" ></a>";
    	return $html;
    }	
    
    
 /* INTERNAL METHOD */
 
    function ReadImageFromFile($filename, $type) {
        
        $imagetypes = imagetypes();

   		switch ($type) {
      	case 2 :
         	if ($imagetypes & IMG_JPEG)
            	return ImageCreateFromJPEG($filename);
            else
            	return FALSE;
         	break;
      	case 3 :
         	if ($imagetypes & IMG_PNG)
            	return ImageCreateFromPNG($filename);
            else
            	return FALSE;
         	break;
      	default:
         	return FALSE;
   		}
   	}
   
	function WriteImageToFile($im, $filename, $type, $quality) {

   		switch ($type) {
      	case 2 :
        	return ImageJpeg($im, $filename, $quality);
        	break;     
      	case 3 :
         	return ImagePNG($im, $filename);
         	break;
      	default:
         	return false;
   		}
   		return false;
	}
    

}

?>






























