<?php
/* _news.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Vincenzo Visciano  <liberodicrederci@yahoo.it>              |
 * |          Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: _news.inc.php,v 1.4.2.1 2002/12/17 22:09:54 AlberT Exp $
 */

require_once AES_SITE_PATH.'/packages/news/common.inc.php';

/**
 *  simple "news" class
 *
 * @access public
 * @return mixed TRUE on success or error string
 */
class _news
{
	var $db         = NULL;      // the db object
	var $newsList   = array();   // bidimentional array containing news
	var $headQuery  = '';        // head query for db
	var $singleNews = FALSE;     // if TRUE shows only a new in extended format,
	                             //  if FALSE it shows a list of news
	var $topicId    = NULL;
	var $newsId     = NULL;
	var $maxNews    = NULL;
	var $title      = NULL;
	var $file       = NULL;

/**
 *  costructor class
 *
 * @access public
 * @return mixed TRUE on success or error string
 */
	function _news()
	{
		$this->_setup_db();
		$this->topicId = (!empty($_GET['topic'])) ? $_GET['topic'] : '';
		$this->newsId  = (!empty($_GET['news'])) ? $_GET['news'] : '';

		/* populate $this->news_list */
		$this->headQuery = 'SELECT id_news, id_author, title, topic_news.description as topic, '.
		                   'news.description as description, text, n_read, news_date, news_link, topic_news.news_img '.
		                   'FROM news, topic_news '.
		                   'WHERE news.id_topic_news = topic_news.id_topic_news ';
		return TRUE;
	}

/**
 * Read a single news
 *
 * @access public
 * @param int $newsId The news ID
 * @return mixed TRUE on success or error string
 */
	function GetById($newsId)
	{
		$query  = $this->headQuery.'AND news.id_news = "'.$newsId.'"';
		$this->newsList = array();
		$success = $this->db->QueryRow($Query, &$this->newsList);
		if (!$success && isset($this->db->error)) {
			AES_print($this->db->error, E_ERROR);
			return FALSE;
		}
		$this->singleNews = TRUE;
		$this->_newsCounter();         // add 1 to news's read number

		return TRUE;
	}

/**
 * Add 1 to news read number
 *
 * @access private
 * @return mixed TRUE on success or error string
 */
	function _newsCounter()
	{
		if (count ($this->newsList[] == 1) {
			$new_n_read = $this->newsList[NEWS_READ_N]+1;
			$update = 'UPDATE news SET n_read = '.$new_n_read.' WHERE id_news = "'.$this->newsList[NEWS_ID].'"';
			$success = $this->db->Query($update);
			if (!$success && isset($this->db->error)) {
				AES_print($this->db->error, E_ERROR);
				return FALSE;
			}
		}

		return TRUE;
	}

/**
 * Read the news by Topic
 *
 * @access public
 * @param int $topicId The topic ID
 * @return mixed TRUE on success or error string
 */
	function GetByTopic($topicId)
	{
		$this->newsList = array();

		$query  = $this->headQuery.'AND news.id_topic_news = "'.$topicId.'"';
		$success = $this->db->QueryAll($query, &this->newsList);
		if (!$success) {
			AES_print($this->db->error, E_ERROR);
			return FALSE;
		}

		return TRUE;
	}


/**
 * Read the recent news
 *
 * @access public
 * @return mixed TRUE on success or error string
 */
	function GetRecent()
	{
		$this->db->SetSelectedRowRange(0, $this->maxNews);
		$this->newsList = array();

		$query  = $this->headQuery.'ORDER BY news_date';
		$success = $this->db->QueryAll($query, &$this->newsList);
		if (!$success) {
			AES_print($this->db->error, E_ERROR);
			return FALSE;
		}
		$this->singleNews = FALSE;

		return TRUE;
	}

/**
 * Initialize the object "db" to connect to DBMS with MetaBase.
 *
 * @access private
 * @return mixed TRUE on success or error string
 */
	function _setup_db()
	{
		$error = MetabaseSetupDatabaseObject( array( 'Type'        => NEWS_MB_TYPE,
		                                             'User'        => NEWS_MB_USER,
		                                             'Password'    => NEWS_MB_PASS,
		                                             'Host'        => NEWS_MB_HOST,
		                                             'IncludePath' => NEWS_MB_DIR),
		                                      $this->db);
		if ($error != '') {
			AES_print($error, E_ERROR);
			return FALSE;
		}

		return $this->db->SetDatabase(NEWS_MB_DB);
	}
}
?>
