<?php
/* setup_news.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; version 2 of the License.              |
 * +----------------------------------------------------------------------+
 * | Authors: Vincenzo Visciano  <liberodicrederci@yahoo.it>              |
 * |          Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: setup_news.php,v 1.5.2.1 2002/12/26 16:29:36 AlberT Exp $
 */
if (!is_array($_POST) || !array_key_exists('initialize', $_POST))
	return FALSE;

switch ($_POST['initialize']) {
	case 'create':
		$createDB = 1;
		break;
	case 'update':
		$createDB = 0;
		break;
}

require_once NEWS_MB_DIR.'/metabase_parser.php';
require_once NEWS_MB_DIR.'/metabase_manager.php';
require_once NEWS_MB_DIR.'/metabase_database.php';
require_once NEWS_MB_DIR.'/metabase_interface.php';
require_once NEWS_MB_DIR.'/xml_parser.php';

$input_file = (!is_readable(dirname(__FILE__).'/myNews.schema.xml')) 
              ? NEWS_MB_DIR.'/test.schema' 
              : dirname(__FILE__).'/myNews.schema.xml';
copy($input_file, AES_TMP.'/news/'.basename($input_file));

$input_file = AES_TMP.'/news/'.basename($input_file);

$variables  = array('db_name'  => NEWS_MB_DB,
                    'create'   => $createDB);

$arguments  = array('Type'        => NEWS_MB_TYPE,
                    'User'        => NEWS_MB_USER,
                    'Password'    => NEWS_MB_PASS,
                    'Host'        => NEWS_MB_HOST,
                    'IncludePath' => NEWS_MB_DIR);

$manager = new metabase_manager_class;
$success = $manager->UpdateDatabase($input_file, $input_file.'.before',
                                    $arguments, $variables);

if (!$success) {
	AES_print(_("Error: ").$manager->error, E_USER_ERROR);
}
else {
	echo 'All right, the DB was created';
}

if (count($manager->warnings)>0) {
	AES_print(_("WARNING:\n").implode($manager->warnings, "!\n"));
}

?>
