<?php
/* AES_news.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Vincenzo Visciano  <liberodicrederci@yahoo.it>              |
 * |          Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: AES_news.inc.php,v 1.12.2.2 2003/02/08 18:43:37 AlberT Exp $
 */

require_once AES_SITE_PATH.'/packages/news/myNews.inc.php';

/**
 * Manages the "news" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_news extends myNews
{

	function AES_news()
	{
		$this->myNews();
		$this->topicId = (is_array($_GET) && array_key_exists('topicId', $_GET)) ? $_GET['topicId'] : '';
		$this->newsId  = (is_array($_GET) && array_key_exists('newsId', $_GET))  ? $_GET['newsId']  : '';

		return TRUE;
	}


	function view($maxNews='', $file='')
	{
		global $AES_objects, $theme;

		$this->SetMaxNews($maxNews);
		if (!empty($this->newsId) && empty($this->topicId)) {
			$this->GetById($this->newsId);
			$file =  (!empty($file) ? AES_SITE_PATH.'/themes/'.$theme.'/'.$file : AES_SITE_PATH.'/themes/'.$theme.'/extNews.thm.php');
			$this->file = ((!is_readable($file) && !is_file($file)) ? AES_SITE_PATH.'/packages/news/extNews.thm.php' : $file);
		}
		if (empty($this->newsId) && !empty($this->topicId)) {
			$this->GetByTopic($this->topicId);
			$file =  (!empty($file) ? AES_SITE_PATH.'/themes/'.$theme.'/'.$file : AES_SITE_PATH.'/themes/'.$theme.'/tabNews.thm.php');
			$this->file = ((!is_readable($file) && !is_file($file)) ? AES_SITE_PATH.'/packages/news/tabNews.thm.php' : $file);
		}
		if (empty($this->newsId) && empty($this->topicId)) {
			$this->GetByRecent();
			$file =  (!empty($file) ? AES_SITE_PATH.'/themes/'.$theme.'/'.$file : AES_SITE_PATH.'/themes/'.$theme.'/tabNews.thm.php');
			$this->file = ((!is_readable($file) && !is_file($file)) ? AES_SITE_PATH.'/packages/news/tabNews.thm.php' : $file);
		}

		return $this->_writeNews();
	}

	function _writeNews()
	{
	    global $AES_objects;
		$parser = new _parseTemplate;

		foreach ($this->newsReaded as $news) {
			$AES_objects['newsIdNews'][1]->newsIdNews         = (!empty($news[NEWS_ID_NEWS]))     ? $news[NEWS_ID_NEWS]     : '' ;
			$AES_objects['newsIdAuthor'][1]->newsIdAuthor     = (!empty($news[NEWS_ID_AUTHOR]))   ? $news[NEWS_ID_AUTHOR]   : '' ;
			$AES_objects['newsTitle'][1]->newsTitle           = (!empty($news[NEWS_TITLE]))       ? $news[NEWS_TITLE]       : '' ;
			$AES_objects['newsSubtitle'][1]->newsSubtitle     = (!empty($news[NEWS_SUBTITLE]))    ? $news[NEWS_SUBTITLE]    : '' ;
			$AES_objects['newsNews'][1]->newsNews             = (!empty($news[NEWS_NEWS]))        ? $news[NEWS_NEWS]        : '' ;
			$AES_objects['newsNRead'][1]->newsNRead           = (!empty($news[NEWS_N_READ]))      ? $news[NEWS_N_READ]      : '0';
			$AES_objects['newsDate'][1]->newsDate             = (!empty($news[NEWS_NEWS_DATE]))   ? $news[NEWS_NEWS_DATE]   : '' ;
			$AES_objects['newsApproved'][1]->newsApproved     = (!empty($news[NEWS_APPROVED]))    ? $news[NEWS_APPROVED]    : '' ;
			$AES_objects['newsAuthorName'][1]->newsAuthorName = (!empty($news[NEWS_AUTHOR_NAME])) ? $news[NEWS_AUTHOR_NAME] : '' ;
			$AES_objects['newsIdTopic'][1]->newsIdTopic       = (!empty($news[NEWS_ID_TOPIC]))    ? $news[NEWS_ID_TOPIC]    : '' ;
			$AES_objects['newsTopic'][1]->newsTopic           = (!empty($news[NEWS_TOPIC]))       ? $news[NEWS_TOPIC]       : '' ;
			$AES_objects['newsImageTopic'][1]->newsImageTopic = (!empty($news[NEWS_IMAGE_TOPIC])) ? $news[NEWS_IMAGE_TOPIC] : '' ;
			//$AES_objects['imageGallery'][1]->images           = $this->GetNewsImages($news[NEWS_ID_NEWS]);
			//$images = $this->GetNewsImages($news[NEWS_ID_NEWS]);
			$cont = 1;
			if (!empty($images)) {
				foreach ($images as $description => $image) {
					$AES_objects['imageCell'][$cont]->imageThumb       = '<img src="http://'.AES_HOST_NAME.NEWS_IMAGES_PATH.'/'.NEWS_THUMB_PREFIX.$image.'">';
					$AES_objects['imageCell'][$cont]->imageDescription = $description;
					$AES_objects['imageCell'][$cont]->imageSource      = 'http://'.AES_HOST_NAME.NEWS_IMAGES_PATH.'/'.$image;
					++$cont;
				}
			}
			$AES_objects['tableLinks'][1]->rows                = $this->GetNewsLinks($news[NEWS_ID_NEWS]);
			$parser->getParsed($this->file);
		}

		return TRUE;
	}
}

/**
 * Manages the "newsIdNews" HTML object.
 *
 * @access public
 */
class AES_newsIdNews
{
	var $newsIdNews = '';

	// manage HTML object 'newsIdNews'
	function manage_newsIdNews()
	{
		echo $this->newsIdNews;

		return TRUE;
	}
}

/**
 * Manages the "newsIdAuthor" HTML object.
 *
 * @access public
 */
class AES_newsIdAuthor
{
	var $newsIdAuthor = '';

	// manage HTML object 'newsIdAuthor'
	function manage_newsIdAuthor()
	{
		echo $this->newsIdAuthor;

		return TRUE;
	}
}

/**
 * Manages the "newsTitle" HTML object.
 *
 * @access public
 */
class AES_newsTitle
{
	var $newsTitle = '';

	// manage HTML object 'newsTitle'
	function manage_newsTitle()
	{
		echo $this->newsTitle;

		return TRUE;
	}
}

/**
 * Manages the "newsSubtitle" HTML object.
 *
 * @access public
 */
class AES_newsSubtitle
{
	var $newsSubtitle = '';

	// manage HTML object 'newsSubtitle'
	function manage_newsSubtitle()
	{
		echo $this->newsSubtitle;

		return TRUE;
	}
}


/**
 * Manages the "newsNews" HTML object.
 *
 * @access public
 */
class AES_newsNews
{
	var $newsNews = '';

	// manage HTML object 'newsNews'
	function manage_newsNews()
	{
		echo $this->newsNews;

		return TRUE;
	}
}

/**
 * Manages the "newsNRead" HTML object.
 *
 * @access public
 */
class AES_newsNRead
{
	var $newsNRead = '';

	// manage HTML object 'newsNRead'
	function manage_newsNRead()
	{
		echo $this->newsNRead;
		
		return TRUE;
	}
}

/**
 * Manages the "newsDate" HTML object.
 *
 * @access public
 */
class AES_newsDate
{
	var $newsDate = '';

	// manage HTML object 'newsDate'
	function manage_newsDate()
	{
		echo $this->newsDate;
		return TRUE;
	}
}

/**
 * Manages the "newsApproved" HTML object.
 *
 * @access public
 */
class AES_newsApproved
{
	var $newsApproved = '';

	// manage HTML object 'newsApproved'
	function manage_newsApproved()
	{
		echo $this->newsApproved;
		return TRUE;
	}
}


/**
 * Manages the "newsAuthorName" HTML object.
 *
 * @access public
 */
class AES_newsAuthorName
{
	var $newsAuthorName = '';

	// manage HTML object 'newsAuthorName'
	function manage_newsAuthorName()
	{
		echo $this->newsAuthorName;

		return TRUE;
	}
}

/**
 * Manages the "newsIdTopic" HTML object.
 *
 * @access public
 */
class AES_newsIdTopic
{
	var $newsIdTopic = '';

	// manage HTML object 'newsIdTopic'
	function manage_newsIdTopic()
	{
		echo $this->newsIdTopic;

		return TRUE;
	}
}

/**
 * Manages the "newsTopic" HTML object.
 *
 * @access public
 */
class AES_newsTopic
{
	var $newsTopic = '';

	// manage HTML object 'newsTopic'
	function manage_newsTopic()
	{
		echo $this->newsTopic;

		return TRUE;
	}
}

/**
 * Manages the "newsImageTopic" HTML object.
 *
 * @access public
 */
class AES_newsImageTopic
{
	var $newsImageTopic = '';

	// manage HTML object 'newsImageTopic'
	function manage_newsImageTopic()
	{
		echo $this->newsImageTopic;

		return TRUE;
	}
}

?>
