<?php
/* AES_zb_news.inc.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                          |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; version 2 of the License.              |
 * +----------------------------------------------------------------------+
 * | Authors: Michel Morelli     <michel@ZioBudda.net>                    |
 * |          Vincenzo Visciano  <liberodicrederci@yahoo.it>              |
 * |          Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id: AES_zb_news.inc.php,v 1.3.2.1 2002/12/18 11:31:08 AlberT Exp $
 */

require AES_SITE_PATH.'/packages/zb_news/zb_news.inc.php';

/**
 * Manages the "zb_news" HTML object.
 *
 * @access public
 * @return mixed TRUE on success or error string
 */
class AES_zb_news extends zb_news
{
	var $catId  = NULL;
	var $newsId = NULL;

	function AES_zb_news()
	{
		$this->zb_news();
		$this->catId     = (!empty($_GET['news_c'])) ? $_GET['news_c'] : '';
		$this->zb_newsId = (!empty($_GET['news']))   ? $_GET['news']   : '';

		return TRUE;
	}

	function manage_zb_news($maxNews=10, $file='')
	{
		global $AES_objects;

		$this->maxNews = (!empty($this->maxNews)) ? $this->maxNews  : $maxNews;
		$this->file    = (!empty($this->file))    ? $this->file : $file;

		// sets the template to the default one if $file fails
		if ( !is_readable($file) && !is_file($file) ) {
			$this->file = AES_SITE_PATH.'/packages/zb_news/templates/tabNews.thm.php';
		}

		$news = $this->getLastNewsData($maxNews, 1);
		if (ZB_NEWS_NO_NEWS == $news)
			echo _('Sorry, no news present!<br>'."\n");
		$parser = new _parseTemplate;

		for ($i=0; $i<count($news['id']); ++$i) {
			$AES_objects['zb_newsId'][1]->zb_newsId             = $news['id'][$i];
			$AES_objects['zb_newsAuthor'][1]->zb_newsAuthor     = $news['who'][$i];
			$AES_objects['zb_newsTitle'][1]->zb_newsTitle       = $news['title'][$i];
			$AES_objects['zb_newsCategory'][1]->zb_newsCategory = $news['category'][$i];
			$AES_objects['zb_newsText'][1]->zb_newsText         = $news['new'][$i];
			$AES_objects['zb_newsReadN'][1]->zb_newsReadN       = $news['redir'][$i];
			$AES_objects['zb_newsDate'][1]->zb_newsDate         = $news['date'][$i];

			$parser->getParsed($this->file);
		}

		return TRUE;
	}
}

/**
 * Manages the "zb_newsId" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsId
{
	var $zb_newsId = '';

	// manage HTML object 'zb_newsId'
	function manage_zb_newsId()
	{
		echo $this->zb_newsId;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsAuthor" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsAuthor
{
	var $zb_newsAuthor = '';

	// manage HTML object 'zb_newsAuthor'
	function manage_zb_newsAuthor()
	{
		echo $this->zb_newsAuthor;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsTitle" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsTitle
{
	var $zb_newsTitle = '';

	// manage HTML object 'zb_newsTitle'
	function manage_zb_newsTitle()
	{
		echo $this->zb_newsTitle;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsTopic" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsCategory
{
	var $zb_newsCategory = '';

	// manage HTML object 'zb_newsTopic'
	function manage_zb_newsCategory()
	{
		echo $this->zb_newsCategory;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsText" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsText
{
	var $zb_newsText = '';

	// manage HTML object 'zb_newsText'
	function manage_zb_newsText()
	{
		echo $this->zb_newsText;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsReadN" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsReadN
{
	var $zb_newsReadN = NULL;

	// manage HTML object 'zb_newsReadN'
	function manage_zb_newsReadN()
	{
		echo $this->zb_newsReadN;
		return TRUE;
	}
}

 /**
 * Manages the "zb_newsDate" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsDate
{
	var $zb_newsDate = '';

	// manage HTML object 'zb_newsDate'
	function manage_zb_newsDate()
	{
		echo $this->zb_newsDate;
		return TRUE;
	}
}

/**
 * Manages the "zb_newsLink" HTML object.
 *
 * @access public
 * @return bool TRUE
 */
class AES_zb_newsLink
{
	var $zb_newsLink = '';

	// manage HTML object 'zb_newsLink'
	function manage_zb_newsLink()
	{
		echo $this->zb_newsLink;
		return TRUE;
	}
}

?>
