<?php
/* qsMaker.inc.php
*
* +----------------------------------------------------------------------+
* |                                                                      |
* | AlberT-EasySite: Web Site Management System                          |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Copyright (c) SuperAlberT.it                                         |
* +----------------------------------------------------------------------+
* | This program is free software. You can redistribute it and/or modify |
* | it under the terms of the GNU General Public License as published by |
* | the Free Software Foundation; either version 2 of the License.       |
* +----------------------------------------------------------------------+
* | Authors:    David Scatigna <david@tomato.it>                         |
* |             Emiliano Gabrielli <AlberT@SuperAlberT.it>               |
* |                                                                      |
* +----------------------------------------------------------------------+
*
* $Id$
*/
class QS_Maker
{
	var $qs;

	//default values for queries
	var $_qsOperator	= "=";
	var $_qsSeparator	= "&";
	var $_qsStart		= "?";

	function set_qsOperator($value)
	{
		$this->_qsOperator = $value;
		return TRUE;
	}

	function set_qsSeparator($value)
	{
		$this->_qsSeparator = $value;
		return TRUE;
	}

	function set_qsStart($value)
	{
		$this->_qsStart = $value;
		return TRUE;
	}

	function loadQS($qs)
	{
		if (!empty($qs)) {
			if ($this->_qsSeparator != $this->_qsOperator) {
				$qs_exp = explode($this->_qsSeparator, $qs);
				foreach ($qs_exp as $key => $value) {
					$qs_datas = explode($this->_qsOperator, $qs_exp[$key]);
					$this->addto_qs($qs_datas[0], $qs_datas[1]);
				}
			}
			else {
				$qs_exp = explode($this->_qsSeparator, $qs);
				for($i=0; $i<count($qs_exp); $i++) {
					$this->addto_qs($qs_exp[$i], $qs_exp[++$i]);
				}
			}
		}
	}

	function addToQS($var, $value)
	{
		if (!empty($var)) {
			$this->qs[$var] = urlencode($value);
		}
	}

	function removeFromQS($var)
	{
		unset($this->qs[$var]);
	}

	function emptyQS()
	{
		unset($this->qs);
	}

	function getQS()
	{
		$qs=$this->_qsStart;
		if (is_array($this->qs)) {
			foreach($this->qs as $k => $v) {
				$build_qs[] = $k.$this->_qsOperator.$v;
			}
			if (is_array($build_qs)) {
				$qs .= implode($this->_qsSeparator, $build_qs);
			}
		}
		return $qs;
	}
}
?>