<?php
/* AES_registerPlugin.php
 *
 * +----------------------------------------------------------------------+
 * |                                                                      |
 * | AlberT-EasySite: Web Site Management System                          |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 * | Copyleft (c) SuperAlberT.it                                         |
 * +----------------------------------------------------------------------+
 * | This program is free software. You can redistribute it and/or modify |
 * | it under the terms of the GNU General Public License as published by |
 * | the Free Software Foundation; either version 2 of the License.       |
 * +----------------------------------------------------------------------+
 * | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
 * |                                                                      |
 * +----------------------------------------------------------------------+
 *
 * $Id$
 */

/*
 * THIS IS A SAMPLE PLUGIN; use it to learn about
 * writing your own personal plugin
 */

// First of all make sure not to include it twice !!
if (defined('AES_pi_HelloWod'))
	return FALSE;
define('AES_pi_HelloWorld', TRUE);

// then define a constant for each HTML object you want
// to enable (pay attention: an other plugin may have defined it before!)
define('hello', TRUE);

// if plugin manage HTML objects, define the maximal number of instances
// it will be possible to have; if undefined defaults to 1.
// The syntax is:  define('AES_MAX_objectname_INSTANCES',  #istances);
define('AES_MAX_hello_INSTANCES', 2);

// Now register the plugin.
// AESinfo()  will display these informations.

// AES_registerPlugin( string 'Plugin Name',
//                     array 'names of objects to manage',
//                     string 'Authors',
//                     string 'version',
//                     string 'description',
//                     bool 'send an output ?');
AES_registerPlugin(  'AES_HelloWorld',
                     array('hello'),
                     'AlberT <AlberT@SuperAlberT.it>',
                     '0.9',
                     'A sample plugin for AES',
                     TRUE);

// Now you can require here the code that do the work
require dirname(__FILE__).'/example.inc.php';

// Now (after inclusion!!!) you have to register a set of functions
// that will be called when the HTML parser reach the object
// you want to manage. These functions have to be ONLY
// an interface... simple and light! They will then call
// the functions or classes or whatever you want that will really
// do the work!
$callbacks = array('hello_print', 'hello_print2');

// AES_addCallback(string 'hello', array $callbacks);
AES_addCallback('hello', $callbacks);


// Finally return TRUE !!!
return TRUE;
?>