<?php
/* defautObjs.inc..php
*
* +----------------------------------------------------------------------+
* |                                                                      |
* | AlberT-EasySite: Web Site Management System                          |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Copyright (c) SuperAlberT.it                                         |
* +----------------------------------------------------------------------+
* | This program is free software. You can redistribute it and/or modify |
* | it under the terms of the GNU General Public License as published by |
* | the Free Software Foundation; either version 2 of the License.       |
* +----------------------------------------------------------------------+
* | Authors: Emiliano Gabrielli <AlberT@SuperAlberT.it>                  |
* |                                                                      |
* +----------------------------------------------------------------------+
*
* $Id$
*/

// title
class AES_title
{
	var $title = AES_SITE_URL;

	// manage HTML object 'title'
	function manage_Title()
	{
		echo $this->title;
		return TRUE;
	}
}

// bodyBgColor
class AES_bodyBgColor
{
	var $bodyBgColor = '#FFFFFF';

	// manage HTML object 'title'
	function manage_bodyBgColor()
	{
		echo $this->bodyBgColor;
		return TRUE;
	}
}

class AES_htmlHeads
{
	var $_htmlHeads = NULL;

	// Add HTML META tags
	function set_htmlHeads($head='')
	{
		$this->_htmlHeads .= "$head\n";
		return TRUE;
	}

	// manage HTML object 'htmlHead'
	function manage_htmlHeads()
	{
		echo '<meta name="Generator" content="AlberT-EasySite '.AES_VERSION.'; http://SuperAlberT.it">'."\n";
		echo $this->_htmlHeads;
		return TRUE;
	}
}

class AES_subDomain
{
	var $_subDomain = NULL;

	// Manage subDomain
	function manage_subDomain($sd='')
	{
		$this->set_subdomain();
		echo $this->_subDomain;
		return TRUE;
	}

	// Set the subdomain
	function set_subDomain($level = 3)
	{
		$domain = $_SERVER['SERVER_NAME'];
		$subs = array_reverse(explode('.', $domain));
		if ((count($subs) - $level +1) > 0) {		// otherwise we have a Warning
			$subDomain = $subs[$level - 1];
		}
		$this->_subDomain = (empty($subDomain)) ? FALSE : strtolower($subDomain);
		return TRUE;
	}
}

class AES_include
{
	var $_include     = NULL;
	var $_defaultPage = NULL;
	var $_parse       = FALSE;

	function AES_include()
	{
		global $theme;

		$this->_defaultPage = AES_SITE_PATH.'/themes/'.$theme.'/defaultPage.thm.php';
		$this->_include = $this->_defaultPage;
		return TRUE;
	}

	// Set the content of the central part
	function set_include($file='', $parse=0)
	{
		if ($file != '') {
			$this->_include = $file;
		}
		$this->_parse = $parse;
		return TRUE;
	}

	function manage_include($file='')
	{
		$parser = NULL;

		$parser = new _parseTemplate;
		if (@is_readable($this->_include)) {
			($this->_parse) ? $parser->getParsed($this->_include) : include $this->_include ;
		}
		elseif (@is_readable($this->_defaultPage)) {
			AES_print("File '<b>$this->_include</b>' unreadable ... including default!");
			($this->_parse) ? $parser->getParsed($this->_defaultPage) : include $this->_defaultPage ;
		}
		else {
			AES_print("Can't open default page: '<b>".$this->_defaultPage."</b>'.".
			          ' Is it present and readable by webserver?', E_ERROR);
		}
		return TRUE;
	}
}

class AES_repeat
{
	function manage_repeat($start='', $end='', $firstDis=0, $lastDis=0)
	{
		$len = 0;
		$parser = new _parseTemplate;

		$content = (!is_array($this->content)) ? array($this->content) : $this->content;

		$len = count($content);
		for ($i=1 ; $i<=$len ; ++$i) {
			if((!$firstDis && $i==1) || $i>1) {
				$parser->_parseContent($start, AES_TEMPLATE_REPEAT_SEPARATOR);
			}
			$parser->_parseContent($content[$i -1], AES_TEMPLATE_REPEAT_SEPARATOR);
			if( (!$lastDis && ($i == $len)) || $i<$len) {
				$parser->_parseContent($end, AES_TEMPLATE_REPEAT_SEPARATOR);
				echo "\n";
			}
		}
		return;
	}
}

class AES_repeatStart
{
	function manage_repeatStart()
	{
		global $AES_parserActive;

		ob_start();
		$AES_parserActive = FALSE;

		return;
	}
}

class AES_repeatEnd
{
	var $times = 1;

	function manage_repeatEnd($times=1)
	{
		global $AES_parserActive;
		$parser = new _parseTemplate;
		$times = ($this->times !== 1 && is_int($this->times)) ? $this->times : (int) $times;
		$out = '';

		if (FALSE === ($cont = ob_get_contents())) {
			AES_print("Repeat end invoked, but no output buffer present.", E_WARNING);
			return FALSE;
		}
		ob_end_clean();
		$AES_parserActive = TRUE;
		while ($times-- > 0) {
			$out .= $cont;
		}
		$parser->_parseContent($out);

		return;
	}
}
?>
